package learner;

import weka.classifiers.trees.J48;
import weka.core.Instance;
import weka.core.Instances;
import weka.core.converters.ConverterUtils.DataSource;

public class J48Learner {
	public Instances instances;
	
	J48 j48; //the j48 classifier
	
	public final String LOG_PATH = "data/aiData/FICE_AI_OM/logOM.arff"; //constant for file name of the training data
	
	public void openFile(String filename) throws Exception{
		 DataSource source = new DataSource(filename);
		 instances = source.getDataSet();
		 
		 // Make the last attribute as the class attribute
		 if (instances.classIndex() == -1){
			 instances.setClassIndex(instances.numAttributes() - 1); 
		 }
		 
	}
	
	public void buildClassifier() throws Exception{
		
		openFile(LOG_PATH);
		
		//options for J48 classifier
		String[] options = new String[4];
		options[0] = "-C";
		options[1] = "0.25";
		options[2] = "-M";
		options[3] = "2";
				
		//build J48 classifier
		j48 = new J48();
		j48.setOptions(options);
		j48.buildClassifier(instances);
		
	}
	
	//classifies a single instance
	//returns name of the predicted action
	public String classifyInstance(Instance curr_instance, String[] actions) throws Exception{
		
		return actions[(int) j48.classifyInstance(curr_instance)];
	}
	
}
