package weighting;

import java.io.Serializable;
import java.util.Vector;

import structs.MotionData;
import enumerate.Action;

/**
 * Describes information about an action
 * @author aldidoanta
 *
 */
public class ActionInfo implements Serializable{

	public String actionName; //the name of the action
	public int weight; //the weight of the action for current range
	public int damage; //the damage inflicted by the action
	public int frameNumber; //number of frames of the action (it doesn't necessarily tell the frame number of the attack)
	
	//constructor
	public ActionInfo(String _actionName, Vector<MotionData> motiondata){
		actionName = _actionName;
		weight = 0;
		damage = motiondata.elementAt(Action.valueOf(_actionName).ordinal()).getAttackHitDamage();
		frameNumber = motiondata.elementAt(Action.valueOf(_actionName).ordinal()).getFrameNumber();
	}
	
	//update weight
	public void updateWeight(int newWeight){
		this.weight = newWeight;
	}
}
