
import java.util.Vector;

import StrategiesClass.*;
import commandcenter.CommandCenter;
import enumerate.Action;
import gameInterface.AIInterface;
import structs.FrameData;
import structs.GameData;
import structs.Key;
import structs.MotionData;

public class AI_ZBY0323 implements AIInterface {

	private Key inputKey;

	private GameData gameData;
	private FrameData frameData;
	private Vector<MotionData> motionData;

	private boolean playerNumber;

	private CommandCenter attackCC;

	private StrategySelecter AIStrSelecter;

	private int frontOppHP = 0;
	private int tempOppHP = 0;

	private Action frontOppAction = Action.STAND;
	private Action tempOppAction = Action.STAND;
	private Action frontMyAction = Action.STAND;
	private Action tempMyAction = Action.STAND;

	String nextSkill;

	int testTime = 0;

	@Override
	public int initialize(GameData arg0, boolean arg1) {
		// TODO Auto-generated method stub

		inputKey = new Key();

		gameData = arg0;
		frameData = new FrameData();
		motionData = arg0.getOpponentMotion(playerNumber);
		playerNumber = arg1;

		AIStrSelecter = new StrategySelecter(playerNumber, gameData);

		AIStrSelecter.readNPASkill();

		attackCC = new CommandCenter();

		return 0;
	}

	@Override
	public String getCharacter() {
		// TODO Auto-generated method stub
		return CHARACTER_ZEN;
	}

	@Override
	public void getInformation(FrameData arg0) {
		// TODO Auto-generated method stub
		this.frameData = arg0;
		attackCC.setFrameData(this.frameData, playerNumber);
	}

	@Override
	public Key input() {
		// TODO Auto-generated method stub
		return inputKey;
	}

	@Override
	public void processing() {
		// TODO Auto-generated method stub

		frontOppHP = tempOppHP;
		frontOppAction = tempOppAction;
		frontMyAction = tempMyAction;

		strProcessing();
		useSkill();

		if (!frameData.getEmptyFlag() && frameData.getRemainingTime() > 0) {
			tempOppHP = frameData.getOpponentCharacter(playerNumber).getHp();
			tempOppAction = frameData.getOpponentCharacter(playerNumber).getAction();
			tempMyAction = frameData.getMyCharacter(playerNumber).getAction();
		}
	}

	@Override
	public void close() {
		// TODO Auto-generated method stub
		if (AIStrSelecter.AIStrategies.printWriter != null) {
			AIStrSelecter.AIStrategies.printWriter.close();
		}
		if (!frameData.getEmptyFlag() && frameData.getRemainingTime() > 0) {
			int myHP = frameData.getMyCharacter(playerNumber).getHp();
			int oppHP = frameData.getOpponentCharacter(playerNumber).getHp();
			String WIN = null;
			if(myHP>oppHP)
				WIN = "Victory!";
			else if(myHP<oppHP)
				WIN = "Defeat!";
			else
				WIN = "Draw!";
					
			System.out.println(WIN+"("+myHP+","+oppHP+")");
		}
	}

	public void useSkill() {
		if (!frameData.getEmptyFlag() && frameData.getRemainingTime() > 0) {
			if (attackCC.getskillFlag()) {
				inputKey = attackCC.getSkillKey();
			}
		}
	}

	public void strProcessing() {
		if (!frameData.getEmptyFlag() && frameData.getRemainingTime() > 0) {
			AIStrSelecter.updataGuard(frameData, inputKey);
			AIStrSelecter.selectNextSkill(frameData, attackCC, inputKey);
			int nowOppHP = frameData.getOpponentCharacter(playerNumber).getHp();

			if (nowOppHP < frontOppHP) {
				AIStrSelecter.AIStrategies.updataTheStr(frameData, frontOppHP - nowOppHP, frontOppAction,
						frontMyAction);

			}

		}
	}

}
