import enumerate.Action;
import enumerate.State;
import gameInterface.AIInterface;

import java.util.Collections;
import java.util.LinkedList;

import structs.CharacterData;
import structs.FrameData;
import structs.GameData;
import structs.Key;
import structs.MotionData;

import commandcenter.CommandCenter;

public class AsuchAI_LEPnkNN implements AIInterface {

	// game val
	GameData gd;
	boolean player;
	Key inputKey;
	CommandCenter cc;
	FrameData fd;
	CharacterData me;
	CharacterData op;

	// other val
	int memoryFrame;
	int myR;
	int myL;
	int myT;
	int myB;
	int opR;
	int opL;
	int opT;
	int opB;

	// predict val
	Position paa;
	kNearestNeighbor kNN;
	int k;
	String predAct;

	// decision val
	double hate;
	int hps;
	double preMyHP;
	double preOpHP;

	double winDegree;

	public int initialize(GameData arg0, boolean arg1) {

		// game
		gd = arg0;
		player = arg1;
		inputKey = new Key();
		cc = new CommandCenter();

		// other
		memoryFrame = 60;

		// pred
		k = 10;
		paa = new Position(memoryFrame, player);
		kNN = new kNearestNeighbor(k, 6);
		double a[] = { 1000, 1000, 1000, 1000, 1000, 1000 };// dummy data
		kNN.addPoint(a, "STAND");

		// dici
		hate = 0;
		hps = 10;
		preMyHP = 0;
		preOpHP = 0;

		return 0;
	}

	public void coordinate() {
		// other
		myR = me.getRight() - me.getX();
		myL = me.getLeft() - me.getX();
		myT = me.getTop() - me.getY();
		myB = me.getBottom() - me.getY();
		opR = op.getRight() - op.getX();
		opL = op.getLeft() - op.getX();
		opT = op.getTop() - op.getY();
		opB = op.getBottom() - op.getY();

		if (!op.front) {
			opR -= 120;
			opL -= 120;
		} else {
			myR -= 120;
			myL -= 120;
		}
	}

	@Override
	public void getInformation(FrameData arg0) {

		// game
		fd = arg0;
		if (fd.getEmptyFlag() || fd.getRemainingTime() <= 0) {
			return;
		}
		cc.setFrameData(fd, player);
		me = cc.getMyCharacter();
		op = cc.getEnemyCharacter();

		coordinate();

		// pred
		int[] newPos = { me.getX(), me.getY(), op.getX(), op.getY() };
		paa.update(newPos);

		// //kNN pred
		double numNow[] = paa.getNumNow(myR, myL, opR, opL);
		predAct = (String) kNN.getAction(numNow);
		// //kNN addPoint
		double[] numkNN = paa.getNumkNN(myR, myL, opR, opL);
		String strAct = op.getAction().name();
		kNN.addPoint(numkNN, strAct);
		if (predAct == null) {
			return;
		}

		// deci
		hate -= (double) 1 / 60 * hps;
		if (preMyHP - (double) me.getHp() > 0) {
			hate += 50 + preMyHP - (double) me.getHp();
		}
		if (preOpHP - (double) op.getHp() > 0) {
			hate -= 50 + preOpHP - (double) op.getHp();
		}
		if (hate < 0) {
			hate = 0;
		}
		preMyHP = me.getHp();
		preOpHP = op.getHp();

		if (cc.getMyHP() != 0 || cc.getEnemyHP() != 0) {
			winDegree = (double) op.getHp() / (me.getHp() + op.getHp());
		} else {
			winDegree = 0.5;
		}

	}

	@Override
	public void processing() {

		if (fd.getEmptyFlag() || fd.getRemainingTime() <= 0) {
			return;
		}

		if (cc.getskillFlag()) {
			inputKey = cc.getSkillKey();
			return;
		}

		inputKey.empty();
		cc.skillCancel();

		int distX;
		int distY;

		int[] predPos = paa.LEP(15);

		if (me.front) {
			distX = predPos[2] - predPos[0] + (opR - opL + myR - myL);
			distY = predPos[1] - predPos[3];
		} else {
			distX = predPos[0] - predPos[2] + (opR - opL + myR - myL);
			distY = predPos[1] - predPos[3];
		}

		if (distX < 0) {
			distX = 0;
		}

		if (hate > 220) {
			hate = 0;
		} else if (hate > 120) {
			if (op.getState() != State.AIR) {
				inputKey.D = true;
			}
			if (me.front) {
				inputKey.L = true;
			} else {
				inputKey.R = true;
			}
			hps = 50;
			return;
		} else {
			hps = 10;
		}

		if (op.getAction() == Action.STAND_D_DF_FA
				&& me.getState() != State.AIR) {// counter

			if (distX < 350 && me.getEnergy() >= 50) {
				cc.commandCall(Action.STAND_D_DB_BB.name());

			} else if (distX >= 350 && distX < 400) {
				cc.commandCall(Action.STAND_D_DB_BA.name());

			} else if (distX < 400) {
				cc.commandCall(Action.FOR_JUMP.name());

			} else if (me.getEnergy() >= 30) {
				cc.commandCall(Action.STAND_D_DF_FB.name());

			} else if (0.5 <= winDegree && distX < 525) {
				cc.commandCall(Action.BACK_JUMP.name());

			} else if (0.5 <= winDegree && distX >= 525) {// crouch_guard
				inputKey.D = true;
				if (me.front) {
					inputKey.L = true;
				} else {
					inputKey.R = true;
				}

			} else {
				cc.commandCall(Action.FOR_JUMP.name());
			}

		} else if (op.getAction() == Action.STAND_D_DF_FB
				&& me.getState() != State.AIR) {
			cc.commandCall(Action.FOR_JUMP.name());

		} else if (op.getAction() == Action.STAND_D_DF_FC
				&& me.getState() != State.AIR) {
			cc.commandCall(Action.FOR_JUMP.name());

		} else if (op.getAction() == Action.THROW_B
				&& me.getState() != State.AIR) {

			Action act = Action.STAND_A;
			cc.commandCall(act.name());

		} else if (predAct.equals("JUMP")) {// pred counter
			cc.commandCall(Action.FOR_JUMP.name());

		} else if (predAct.startsWith("AIR") && !predAct.equals("AIR")
				&& distX < 200) {
			cc.commandCall(Action.STAND_F_D_DFA.name());

		} else if (predAct.startsWith("AIR") && !predAct.equals("AIR")
				&& distX >= 200) {

			if (me.getEnergy() >= 30) {
				cc.commandCall(Action.STAND_D_DF_FB.name());
			} else {
				cc.commandCall(Action.STAND_D_DF_FA.name());
			}
		} else if (!(me.getState().equals(State.AIR)) && distX < 200) {

			// search reachable attack
			Action[] actArray = { Action.THROW_A, Action.STAND_A,
					Action.STAND_B, Action.CROUCH_A, Action.CROUCH_B,
					Action.CROUCH_FA, Action.CROUCH_FB, Action.STAND_F_D_DFA };
			LinkedList<Action> actList = new LinkedList<Action>();
			for (Action action : actArray) {
				actList.add(action);
			}
			if (me.getEnergy() >= 50) {
				Action[] tmp = { Action.STAND_F_D_DFB };
				for (Action action : tmp) {
					actList.add(action);
				}
			}
			Collections.shuffle(actList);
			for (Action act : actList) {
				if (isHit(act)) {
					cc.commandCall(act.name());
					return;
				}
			}

			if (winDegree > 0.5) {
				// guard
				if (op.getState() != State.AIR) {
					inputKey.D = true;
				}
				if (me.front) {
					inputKey.L = true;
				} else {
					inputKey.R = true;
				}

			} else {// close to opponent
				if (me.front) {
					inputKey.R = true;
				} else {
					inputKey.L = true;
				}
			}

		} else if (!(me.getState().equals(State.AIR)) && distX >= 200
				&& distX < 300 && me.getX() < 500 && me.getX() > 60) {
			if (Math.random() < 0.10) {
				cc.commandCall(Action.FOR_JUMP.name());
			} else {
				if (me.front) {
					inputKey.R = true;
				} else {
					inputKey.L = true;
				}
			}
		} else if (!(me.getState().equals(State.AIR)) && distX >= 300
				&& distX < 550) {
			cc.commandCall(Action.STAND_D_DF_FA.name());

		} else if (!(me.getState().equals(State.AIR)) && winDegree > 0.6) {
			cc.commandCall(Action.FOR_JUMP.name());

		} else if (me.getState() == State.AIR && distX < 200) {
			if (me.getSpeedY() > 0 && distY < -10) {
				cc.commandCall(Action.AIR_DB.name());
			} else {
				//AIR_B
				inputKey.B = true;
			}
		}
		else if (me.front && me.getX() + me.getSpeedX() * 14 < 720) {
			inputKey.R = true;
		} else if (!me.front && me.getX() + me.getSpeedX() * 14 > -160) {
			inputKey.L = true;
		}

	}

	public boolean isHit(Action act) {
		MotionData myMotion = new MotionData();
		myMotion = gd.getMyMotion(player).elementAt(act.ordinal());
		int actL = myMotion.getAttackHit().getL();
		int actR = myMotion.getAttackHit().getR();
		int actT = myMotion.getAttackHit().getT();
		int actB = myMotion.getAttackHit().getB();

		int distX;
		int distY;

		int predPos[] = paa.LEP(15 + myMotion.getAttackStartUp());

		if (me.front) {
			distX = predPos[2] - predPos[0] + (opR - opL + myR - myL);
			distY = predPos[1] - predPos[3];
		} else {
			distX = predPos[0] - predPos[2] + (opR - opL + myR - myL);
			distY = predPos[1] - predPos[3];
		}

		if (distX < 0) {
			distX = 0;
		}

		if (distX < actR - myR && distX > actL - myR - (opR - opL)
				&& distY - (opT - 100) > myT - actB
				&& distY - (opB - 305) < myT - actT + (opB - opT)) {
			return true;
		} else {
			return false;
		}

	}

	public Key input() {
		return inputKey;
	}

	public String getCharacter() {
		return CHARACTER_ZEN;
	}

	public void close() {

	}
}