import structs.FrameData;
import structs.GameData;
import structs.Key;
import gameInterface.AIInterface;
import commandcenter.CommandCenter;

//XOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXO
		// DEVELOPED BY : Renan Motta Goulart
		// Universidade Federal de Juiz de Fora, 2015
		// CONTACT INFO : raikoalihara@hotmail.com, renan.aganai@gmail.com
//XOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXO

public class DragonWarrior implements AIInterface {

	private boolean playerNumber;
	private Key inputKey;
	private FrameData frameData;
	private GameData gameData;
	private CommandCenter cc;
	private String enemyChar; 
	/*
	//probabilidade dos ataques
		//throw
			private int EP_Throw_A; --> 0
			private int EP_Throw_B; --> 1
		//
		//High
			private int EP_Stand_F_D_DFA; --> 2
			private int EP_Stand_D_DF_FC; --> 3
			private int EP_Stand_A; --> 4
			private int EP_Stand_B; --> 5
			private int EP_Stand_FA; --> 6
			private int EP_Stand_D_DF_FA; --> 7
			private int EP_Stand_D_DF_FB; --> 8
			private int EP_Stand_D_DB_BB; --> 9
		//
		//Middle
			private int EP_Stand_F_D_DFB; --> 10
			private int EP_Stand_FB; --> 11
			private int EP_Stand_D_DB_BA; --> 12
		//
		//Low
			private int EP_Crouch_A; --> 13
			private int EP_Crouch_FA; --> 14
			private int EP_Crouch_B; --> 15
			private int EP_Crouch_FB; --> 16
		//
		//total 
		 */
	//variaveis do aprendizado
		private int i, j;//variavel usada nos for
		//private int enemy_totalAttacks;//quantidade total de ataques utilizados pelo oponente ate agora
		private int qtdAttacks = 17+14;//ground+air
		private int[] EPs = new int[qtdAttacks];//quantidade de vezes que ele utilizou os ataques
		private int[] EAAverage = new int[qtdAttacks];
		private int[] EAcounter = new int[qtdAttacks];
		private int memorySize = 10;
		private int[] EAADistances = new int[memorySize*qtdAttacks];
		private int[] EAStdDeviation = new int[qtdAttacks];
		private int[] EAmaxDistance = new int[qtdAttacks];//distancia maxima que o oponete utilizou os ataques
		private int[] EAminDistance = new int[qtdAttacks];//distancia minima que o oponenten utilizou os ataques
		private int[] Adistance = {150, 150, 250, 240, 220, 240, 240, 250, 300, 300, 240, 240, 128, 220, 250, 240, 250, 300, 300, 300, 300, 300, 300, 300, 300, 300, 300, 300, 300, 300, 300};//new int[17];
		private int[] AdistanceG = {250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 650, 650, 900, 250, 250, 250, 300, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250};
		private String[] calls = {"4 _ A", "4 _ B", "6 2 3 _ A", "2 3 6 _ C", "A", "B", "6 _ A", "2 3 6 _ A", "2 3 6 _ B", "2 1 4 _ B", "6 2 3 _ B", "6 _ B", "2 1 4 _ A", "2 _ A", "3 _ A", "2 _ B", "3 _ B", "A", "B", "2 _ A", "2 _ B", "6 _ A", "6 _ B", "8 _ A", "8 _ B", "2 3 6 _ A", "2 3 6 _ B", "6 2 3 _ A", "6 2 3 _ B", "2 1 4 _ A", "2 1 4 _ B"};
		private String[] callsG = {"4 _ A", "4 _ B", "A", "B", "2 _ A", "2 _ B", "6 _ A", "6 _ B", "3 _ A", "3 _ B", "2 3 6 _ A", "2 3 6 _ B", "2 3 6 _ C", "6 2 3 _ A", "6 2 3 _ B", "2 1 4 _ A", "2 1 4 _ B", "A", "B", "2 _ A", "2 _ B", "6 _ A", "6 _ B", "8 _ A", "8 _ B", "2 3 6 _ A", "2 3 6 _ B", "6 2 3 _ A", "6 2 3 _ B", "2 1 4 _ A", "2 1 4 _ B"};
		private String[] callsZ = {"THROW_A", "THROW_B", "STAND_A", "STAND_B", "CROUCH_A", "CROUCH_B", "STAND_FA", "STAND_FB", "CROUCH_FA", "CROUCH_FB", "STAND_D_DF_FA", "STAND_D_DF_FB", "STAND_D_DF_FC", "STAND_F_D_DFA", "STAND_F_D_DFB", "STAND_D_DB_BA", "STAND_D_DB_BB",  "AIR_A", "AIR_B", "AIR_DA", "AIR_DB", "AIR_FA", "AIR_FB", "AIR_UA", "AIR_UB", "AIR_D_DF_FA", "AIR_D_DF_FB", "AIR_F_D_DFA", "AIR_F_D_DFB", "AIR_D_DB_BA", "AIR_D_DB_BB"};
		private String[] calls2 = {"THROW_A", "THROW_B", "STAND_F_D_DFA", "EP_STAND_D_DF_FC", "STAND_A", "STAND_B", "STAND_FA", "STAND_D_DF_FA", "STAND_D_DF_FB", "STAND_D_DB_BB", "STAND_F_D_DFB", "STAND_FB", "STAND_D_DB_BA", "CROUCH_A", "CROUCH_FA", "CROUCH_B", "CROUCH_FB", "AIR_A", "AIR_B", "AIR_DA", "AIR_DB", "AIR_FA", "AIR_FB", "AIR_UA", "AIR_UB", "AIR_D_DF_FA", "AIR_D_DF_FB", "AIR_F_D_DFA", "AIR_F_D_DFB", "AIR_D_DB_BA", "AIR_D_DB_BB"};
		private int probTotal;
		private int ataqueEscolhido;//ataque que se acredita que o oponente vai usar agora
		private int ataqueEscolhidoContador;//contadr para se desidir qual ataque o oponente deve utilizar agora
		private int tempoFimAtaqueInimigo;//tempo que falata para o ataque acabar
		
		private Boolean mostraBoo = true;
		
	//
	
	@Override
	public void close() {
		// TODO Auto-generated method stub

	}

	@Override
	public String getCharacter() {
		return CHARACTER_ZEN;
	}

	@Override
	public void getInformation(FrameData arg0) {
		this.frameData = arg0;
		cc.setFrameData(this.frameData, playerNumber);
	}

	@Override
	public int initialize(GameData gameData, boolean playerNumber) {
		this.playerNumber = playerNumber;
		this.gameData = gameData;
		this.inputKey = new Key();
		cc = new CommandCenter();
		frameData = new FrameData();
		for(i=0;i<17;i++)
		{
			EAmaxDistance[i] = 0;
			EAminDistance[i] = 9999;
		}
		return 0;
	}

	@Override
	public Key input() {
		return inputKey;
	}

	@Override
	public void processing() {
		if (!frameData.getEmptyFlag() && frameData.getRemainingTime() > 0)//linha obrigatria segundo a documentao
		{
			if(playerNumber == true)
				enemyChar = gameData.getPlayerTwoCharacterName();
			else
				enemyChar = gameData.getPlayerOneCharacterName();
			if (cc.getskillFlag())//testa se um skill esta sendo "inputado"(no sei como falar isso em portugus)
			{
				inputKey = cc.getSkillKey();//caso sim entao continua a inputar ele
			}
			else
			{
				if(frameData.getRemainingTime() > 55000)
				{
					 mostraBoo = true;
				}
				if(frameData.getRemainingTime() < 5000 && mostraBoo == true)
				{
					System.out.println(" ");
					System.out.println("1-> Average:"+EAAverage[1]+"   StdDeviation: "+EAStdDeviation[1]);
					System.out.println("8-> Average:"+EAAverage[8]+"   StdDeviation: "+EAStdDeviation[8]);
					System.out.println("9-> Average:"+EAAverage[9]+"   StdDeviation: "+EAStdDeviation[9]);
					System.out.println("10-> Average:"+EAAverage[10]+"   StdDeviation: "+EAStdDeviation[10]);
					System.out.println("12-> Average:"+EAAverage[12]+"   StdDeviation: "+EAStdDeviation[12]);
					System.out.println("3-> Average:"+EAAverage[3]+"   StdDeviation: "+EAStdDeviation[3]);
					mostraBoo = false;
				}
				inputKey.empty();//limpa a inputKey(reseta/reinicia ela)
				cc.skillCancel();//limpa skillData(array que contem a sequcia de botoes para serem apertados) e marca skillFlag como false
				
				//Espera o inimigo finalizar o ataque dele, ainda da pra melhorar esta linha em relacao ao status atual do inimigo tambem...
					if(tempoFimAtaqueInimigo > 0)
					{
						tempoFimAtaqueInimigo -= 1;
					}
				//
				//Descobre qual ataque o inimigo utiliza em relacao a distancia
					if(tempoFimAtaqueInimigo == 0)
					{
						for(i=0;i<qtdAttacks;i++)
						{
							if(cc.getEnemyCharacter().getAction().name().equals(callsZ[i]))
							{
								EPs[i] += 1;
								tempoFimAtaqueInimigo = cc.getEnemyCharacter().getRemainingFrame();
								EAADistances[memorySize*i+EAcounter[i]] = cc.getDistanceX();
								EAAverage[i] = 0;
								if(EPs[i] >= memorySize-1)
								{
									for(j=0;j<memorySize;j++)
										EAAverage[i]+=EAADistances[memorySize*i+j];
								}
								else
								{
									for(j=0;j<EPs[i];j++)
										EAAverage[i]+=EAADistances[memorySize*i+j];
								}
								EAAverage[i] = EAAverage[i]/memorySize;
								EAStdDeviation[i] = 0;
								for(j=0;j<memorySize;j++)
								{
									EAStdDeviation[i] += (EAADistances[memorySize*i+j]-EAAverage[i])*(EAADistances[memorySize*i+j]-EAAverage[i]);
								}
								EAStdDeviation[i] = EAStdDeviation[i]/memorySize;
								EAStdDeviation[i] =(int) Math.sqrt(EAStdDeviation[i]);
								if(EAcounter[i] == memorySize-1)
									EAcounter[i] = 0;
								else
									EAcounter[i]+=1;
								EAmaxDistance[i] = EAAverage[i]+EAStdDeviation[i];
								EAminDistance[i] = EAAverage[i]-EAStdDeviation[i];
							}
						}
					}
				//
				
				//Procura quais ataques o inimigo pode utilizar nesta distancia
					probTotal = 0;
					ataqueEscolhido = 0;
					ataqueEscolhidoContador = 0;
					for(i=0;i<qtdAttacks;i++)
					{
						if(cc.getDistanceX() <= EAmaxDistance[i] && cc.getDistanceX() >= EAminDistance[i])
							probTotal += EPs[i];
					}
					if(probTotal == 0)
					{
						ataqueEscolhido = (int) (Math.random()*(qtdAttacks-1));//utilizando uma heiristica bem simples de escolher um ataque randomicamente. Vale a pena melhorar isto em versoes futuras
					}
					else
					{
						ataqueEscolhido = (int) (Math.random()*probTotal);//TESTAR SE ISTO ESTA FUNCIONANDO MESMO, talvez tenha um modo melhor de se realizar isto utilizando a classe "Random"
						for(i=0;i<qtdAttacks;i++)
						{
							if(cc.getDistanceX() <= EAmaxDistance[i] && cc.getDistanceX() >= EAminDistance[i])
							{
								ataqueEscolhidoContador += EPs[i];
								if(ataqueEscolhidoContador >= ataqueEscolhido)
								{
									ataqueEscolhido = i;
									i = 1000;
								}
							}
						}
					}
				//
					
				//Decide qual ataque sera utilizado
					
					if(enemyChar == "GARNET")
					{
						if(cc.getMyEnergy() > 300)
						{
							if(cc.getMyCharacter().getState().name().equals("STAND") || cc.getMyCharacter().getState().name().equals("CROUCH") && ataqueEscolhido<17)
							{
								cc.commandCall(callsG[12]);
							}
						}
						else if(ataqueEscolhido == 0)
						{
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 1)
						{
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 2)
						{
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 3)
						{
							if(cc.getDistanceX() <= AdistanceG[13] && cc.getMyEnergy() > 30)
								cc.commandCall(callsG[13]);
							if(cc.getDistanceX() <= AdistanceG[1])
								cc.commandCall(callsG[1]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 4)
						{
							if(cc.getDistanceX() <= AdistanceG[13])
								cc.commandCall(callsG[13]);
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 5)
						{
							if(cc.getDistanceX() <= AdistanceG[13] && cc.getMyEnergy() > 30)
								cc.commandCall(callsG[13]);
							if(cc.getDistanceX() <= AdistanceG[1])
								cc.commandCall(callsG[1]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 6)
						{
							if(cc.getDistanceX() <= AdistanceG[5])
								cc.commandCall(callsG[5]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 7)
						{
							if(cc.getDistanceX() <= AdistanceG[16] && cc.getMyEnergy() > 50)
								cc.commandCall(callsG[16]);
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 8)
						{
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 9)
						{
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 10)
						{
							if(cc.getMyCharacter().getState().name().equals("STAND") || cc.getMyCharacter().getState().name().equals("CROUCH"))
								cc.commandCall("JUMP");
							else
								cc.commandCall(callsG[22]);
						}
						else if(ataqueEscolhido == 11)
						{
							if(cc.getDistanceX() <= AdistanceG[16] && cc.getMyEnergy() > 50)
								cc.commandCall(callsG[16]);
							if(cc.getDistanceX() <= AdistanceG[4])
								cc.commandCall(callsG[4]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 12)
						{
							cc.commandCall("GUARD");
						}
						else if(ataqueEscolhido == 13)
						{
							if(cc.getDistanceX() <= AdistanceG[2])
								cc.commandCall(callsG[2]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 14)
						{
							if(cc.getDistanceX() <= AdistanceG[9])
								cc.commandCall(callsG[9]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 15)
						{
							if(cc.getDistanceX() <= AdistanceG[9])
								cc.commandCall(callsG[9]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 16)
						{
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 17)
						{
							if(cc.getDistanceX() <= AdistanceG[11])
								cc.commandCall(callsG[11]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 18)
						{
							if(cc.getDistanceX() <= AdistanceG[11])
								cc.commandCall(callsG[11]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 19)
						{
							if(cc.getDistanceX() <= AdistanceG[4])
								cc.commandCall(callsG[4]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 20)
						{
							if(cc.getDistanceX() <= AdistanceG[4])
								cc.commandCall(callsG[4]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 21)
						{
							if(cc.getDistanceX() <= AdistanceG[4])
								cc.commandCall(callsG[4]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 22)
						{
							if(cc.getDistanceX() <= AdistanceG[9])
								cc.commandCall(callsG[9]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 23)
						{
							if(cc.getDistanceX() <= AdistanceG[4])
								cc.commandCall(callsG[4]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 24)
						{
							if(cc.getDistanceX() <= AdistanceG[4])
								cc.commandCall(callsG[4]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 25)
						{
							if(cc.getDistanceX() <= AdistanceG[9])
								cc.commandCall(callsG[9]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 26)
						{
								cc.commandCall("DASH");
						}
						else if(ataqueEscolhido == 27)
						{
							if(cc.getDistanceX() <= AdistanceG[4])
								cc.commandCall(callsG[4]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 28)
						{
							if(cc.getDistanceX() <= AdistanceG[4])
								cc.commandCall(callsG[4]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 29)
						{
							if(cc.getDistanceX() <= AdistanceG[4])
								cc.commandCall(callsG[4]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 30)
						{
							if(cc.getDistanceX() <= AdistanceG[4])
								cc.commandCall(callsG[4]);
							else
								escolhaPadrao();
						}
						
						
					}
					else if(enemyChar == "ZEN")
					{
						if(cc.getMyEnergy() > 300)
						{
							if(cc.getMyCharacter().getState().name().equals("STAND") || cc.getMyCharacter().getState().name().equals("CROUCH") && ataqueEscolhido<17)
							{
								cc.commandCall(callsG[12]);
							}
						}
						else if(ataqueEscolhido == 0)
						{
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							if(cc.getDistanceX() <= AdistanceG[16] && cc.getMyEnergy() > 50)
								cc.commandCall(callsG[16]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 1)
						{
							if(cc.getDistanceX() <= AdistanceG[5])
								cc.commandCall(callsG[5]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 2)
						{
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 3)
						{
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 4)
						{
							if(cc.getDistanceX() <= AdistanceG[13])
								cc.commandCall(callsG[13]);
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 5)
						{
							if(cc.getDistanceX() <= AdistanceG[13] && cc.getMyEnergy() > 30)
								cc.commandCall(callsG[13]);
							else if(cc.getMyCharacter().getState().name().equals("STAND") || cc.getMyCharacter().getState().name().equals("CROUCH"))
								cc.commandCall("JUMP");
							else
								cc.commandCall(callsG[22]);
						}
						else if(ataqueEscolhido == 6)
						{
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 7)
						{
							if(cc.getDistanceX() <= AdistanceG[16] && cc.getMyEnergy() > 50)
								cc.commandCall(callsG[16]);
							if(cc.getDistanceX() <= AdistanceG[4])
								cc.commandCall(callsG[4]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 8)
						{
							if(cc.getDistanceX() <= AdistanceG[16] && cc.getMyEnergy() > 50)
								cc.commandCall(callsG[16]);
							if(cc.getDistanceX() <= AdistanceG[4])
								cc.commandCall(callsG[4]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 9)
						{
							if(cc.getMyCharacter().getState().name().equals("STAND") || cc.getMyCharacter().getState().name().equals("CROUCH"))
								cc.commandCall("JUMP");
							else
								cc.commandCall(callsG[22]);
						}
						else if(ataqueEscolhido == 10)
						{
							if(cc.getMyCharacter().getState().name().equals("STAND") || cc.getMyCharacter().getState().name().equals("CROUCH"))
								cc.commandCall("JUMP");
							else
								cc.commandCall(callsG[22]);
						}
						else if(ataqueEscolhido == 11)
						{
							if(cc.getDistanceX() <= AdistanceG[16] && cc.getMyEnergy() > 50)
								cc.commandCall(callsG[16]);
							if(cc.getDistanceX() <= AdistanceG[4])
								cc.commandCall(callsG[4]);
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 12)
						{
							cc.commandCall("GUARD");
						}
						else if(ataqueEscolhido == 13)
						{
							if(cc.getDistanceX() <= AdistanceG[4])
								cc.commandCall(callsG[4]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 14)
						{
							if(cc.getDistanceX() <= AdistanceG[13] && cc.getMyEnergy() > 50)
								cc.commandCall(callsG[13]);
							else if(cc.getMyCharacter().getState().name().equals("STAND") || cc.getMyCharacter().getState().name().equals("CROUCH"))
								cc.commandCall("JUMP");
							else
								cc.commandCall(callsG[22]);
						}
						else if(ataqueEscolhido == 15)
						{
							if(cc.getDistanceX() <= AdistanceG[16] && cc.getMyEnergy() > 50)
								cc.commandCall(callsG[16]);
							if(cc.getDistanceX() <= AdistanceG[9])
								cc.commandCall(callsG[9]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 16)
						{
							if(cc.getDistanceX() <= AdistanceG[16] && cc.getMyEnergy() > 50)
								cc.commandCall(callsG[16]);
							else 
								cc.commandCall("GUARD");
						}
						else if(ataqueEscolhido == 17)
						{
							if(cc.getDistanceX() <= AdistanceG[9])
								cc.commandCall(callsG[9]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 18)
						{
							if(cc.getDistanceX() <= AdistanceG[9])
								cc.commandCall(callsG[9]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 19)
						{
							if(cc.getDistanceX() <= AdistanceG[9])
								cc.commandCall(callsG[9]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 20)
						{
							if(cc.getDistanceX() <= AdistanceG[11])
								cc.commandCall(callsG[11]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 21)
						{
							if(cc.getDistanceX() <= AdistanceG[11])
								cc.commandCall(callsG[11]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 22)
						{
							if(cc.getDistanceX() <= AdistanceG[11])
								cc.commandCall(callsG[11]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 23)
						{
							if(cc.getDistanceX() <= AdistanceG[11])
								cc.commandCall(callsG[11]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 24)
						{
							if(cc.getDistanceX() <= AdistanceG[9])
								cc.commandCall(callsG[9]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 25)
						{
							if(cc.getDistanceX() <= AdistanceG[11])
								cc.commandCall(callsG[11]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 26)
						{
							if(cc.getDistanceX() <= AdistanceG[11])
								cc.commandCall(callsG[11]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 27)
						{
							if(cc.getDistanceX() <= AdistanceG[11])
								cc.commandCall(callsG[11]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 28)
						{
							if(cc.getDistanceX() <= AdistanceG[11])
								cc.commandCall(callsG[11]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 29)
						{
							if(cc.getDistanceX() <= AdistanceG[8])
								cc.commandCall(callsG[8]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 30)
						{
							if(cc.getDistanceX() <= AdistanceG[8])
								cc.commandCall(callsG[8]);
							else
								escolhaPadrao();
						}
					}
					else if(enemyChar == "LUD")
					{
						if(cc.getMyEnergy() > 300)
						{
							if(cc.getMyCharacter().getState().name().equals("STAND") || cc.getMyCharacter().getState().name().equals("CROUCH") && ataqueEscolhido<17)
							{
								cc.commandCall(callsG[12]);
							}
						}
						else if(ataqueEscolhido == 0)
						{
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 1)
						{
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 2)
						{
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 3)
						{
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 4)
						{
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 5)
						{
							if(cc.getDistanceX() <= AdistanceG[13] && cc.getMyEnergy() > 30)
								cc.commandCall(callsG[13]);
							if(cc.getDistanceX() <= AdistanceG[1])
								cc.commandCall(callsG[1]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 6)
						{
							if(cc.getDistanceX() <= 250)
								cc.commandCall("6");
							if(cc.getDistanceX() <= 250)
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 7)
						{
							if(cc.getDistanceX() <= 250)
								cc.commandCall("6");
							if(cc.getDistanceX() <= 250)
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 8)
						{
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 9)
						{
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 10)
						{
							if(cc.getMyCharacter().getState().name().equals("STAND") || cc.getMyCharacter().getState().name().equals("CROUCH"))
								cc.commandCall("JUMP");
							else
								cc.commandCall(callsG[22]);
						}
						else if(ataqueEscolhido == 11)
						{
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 12)
						{
							if(cc.getDistanceX() <= AdistanceG[7])
								cc.commandCall(callsG[7]);
						}
						else if(ataqueEscolhido == 13)
						{
							if(cc.getDistanceX() <= AdistanceG[13])
								cc.commandCall(callsG[13]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 14)
						{
							if(cc.getDistanceX() <= AdistanceG[13])
								cc.commandCall(callsG[13]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 15)
						{
							if(cc.getDistanceX() <= AdistanceG[9])
								cc.commandCall("6");
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 16)
						{
							if(cc.getDistanceX() <= AdistanceG[3])
								cc.commandCall(callsG[3]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 17)
						{
							if(cc.getDistanceX() <= AdistanceG[11])
								cc.commandCall(callsG[11]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 18)
						{
							if(cc.getDistanceX() <= AdistanceG[11])
								cc.commandCall(callsG[11]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 19)
						{
							if(cc.getDistanceX() <= AdistanceG[9])
								cc.commandCall(callsG[9]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 20)
						{
							if(cc.getDistanceX() <= AdistanceG[8])
								cc.commandCall(callsG[8]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 21)
						{
							if(cc.getDistanceX() <= AdistanceG[11])
								cc.commandCall(callsG[11]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 22)
						{
							if(cc.getDistanceX() <= AdistanceG[9])
								cc.commandCall(callsG[9]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 23)
						{
							if(cc.getDistanceX() <= AdistanceG[9])
								cc.commandCall(callsG[9]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 24)
						{
							if(cc.getDistanceX() <= AdistanceG[9])
								cc.commandCall(callsG[9]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 25)
						{
							if(cc.getDistanceX() <= AdistanceG[8])
								cc.commandCall(callsG[8]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 26)
						{
							if(cc.getDistanceX() <= AdistanceG[9])
								cc.commandCall(callsG[9]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 27)
						{
							if(cc.getDistanceX() <= AdistanceG[11])
								cc.commandCall(callsG[11]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 28)
						{
							if(cc.getDistanceX() <= AdistanceG[9])
								cc.commandCall(callsG[9]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 29)
						{
							if(cc.getDistanceX() <= AdistanceG[8])
								cc.commandCall(callsG[8]);
							else
								escolhaPadrao();
						}
						else if(ataqueEscolhido == 30)
						{
							if(cc.getDistanceX() <= AdistanceG[9])
								cc.commandCall(callsG[9]);
							else
								escolhaPadrao();
						}
					}
					else
						escolhaPadrao();
					
			}
			
		}

	}

	private void escolhaPadrao()
	{
		if(cc.getMyEnergy()>= 300)
			cc.commandCall(callsG[12]);
		else if (cc.getMyEnergy()> 50)
			cc.commandCall(callsG[16]);
		else
			cc.commandCall(callsG[(int) (Math.random()*16)]);
	}
}